<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:str="http://exslt.org/strings"
	extension-element-prefixes="str"
>
<xsl:strip-space elements="*" />
<xsl:output encoding="utf-8" method="text" />

<xsl:template match="xml">
	<xsl:call-template name="wikipath">
		<xsl:with-param name="id" select="$id"/>
	</xsl:call-template>
	<xsl:text>&#10;----&#10;</xsl:text>

	<xsl:text>====== </xsl:text>
	<xsl:call-template name="title">
		<xsl:with-param name="id" select="$id" />
	</xsl:call-template>
	<xsl:text> ======&#10;</xsl:text>

	<xsl:apply-templates select="node[@id=$id]"/>
</xsl:template>

<xsl:template match="node">
	<xsl:for-each select="link">

		<xsl:text>  * [[</xsl:text>
			<xsl:call-template name="title">
				<xsl:with-param name="id" select="@id" />
			</xsl:call-template>
		<xsl:text>]]</xsl:text>

		<xsl:text>&#10;</xsl:text>
	</xsl:for-each>
</xsl:template>

<!--- char *title(int node_id) -->
<xsl:template name="title">
	<xsl:param name="id" />
	<xsl:value-of select="/xml/titles/node[@id=$id]/@title"/>
</xsl:template>

<!--- char *wikipath(int id) -->
<xsl:template name="wikipath">
	<xsl:param name="id" />

	<xsl:variable name="parent_id"><xsl:value-of select="//titles/node[@id=$id]/@parent_id" /></xsl:variable>

	<xsl:if test="$parent_id != 0">
		<xsl:call-template name="wikipath">
			<xsl:with-param name="id" select="$parent_id" />
		</xsl:call-template>
		<xsl:text> &gt;&gt; </xsl:text>
	</xsl:if>

	<xsl:text>**[[</xsl:text>
		<xsl:call-template name="title">
			<xsl:with-param name="id" select="$id" />
		</xsl:call-template>
	<xsl:text>]]**</xsl:text>

</xsl:template>

</xsl:stylesheet>
