#!/bin/sh
set -e

xml=$1
if [ "$2" ]; then
	id=$2
else
	id=$(basename $xml .xml)
fi

file=$(./wikiname.php $id) || rc=$? && rc=$?
if [ $rc != 0 ]; then
	echo >&2 "$file"
	exit $rc
fi
mkdir -p $(dirname "$file")
echo "parsing into $file"
xsltproc --param id "$id" --xinclude cowiki.xsl $xml > $file
chmod a+rw $file
